#include <QtCore/QCoreApplication>
#include "processor.h"

int main(int argc, char * argv [])
{

  QCoreApplication app(argc, argv);

  if(app.arguments().contains("-listcuda")){
    CudaDevice::printCudaDevices();
    return EXIT_SUCCESS;
  }

  QString cubinGenerator = "../cubin/gener_f.cubin";
  QString prjFileName = "../prj.xml";;

  qDebug() << app.arguments().first();

  if(app.arguments().contains("-cubin") )
    cubinGenerator = app.arguments().at(1 + app.arguments().indexOf("-cubin"));

  if(app.arguments().contains("-xml") )
    prjFileName = app.arguments().at(1 + app.arguments().indexOf("-xml"));

  ProcessorF proc(cubinGenerator, prjFileName);

  return proc.process();

}
