#ifndef PROCESSOR_H
#define PROCESSOR_H

#include "stabil.h"

class ProcessorF
{
  ProjectF prj;
  ProjectDataF * data;
  CalcDataF * calcData;
  CudaDevice * dev;
  Stabilisation * stabilisation;

  int calcDataCount;
  QString  cubinGenerator;
  QString  prjFileName;
  QString  physicsFileName;
  QString  outMolFileBase;

public:
  ProcessorF(QString _cubinGenerator, QString _prjFileName, QString _physicsFileName = QString::null);

  int process(int devId = 0);

private:

  bool checkProject();

  int clearProject(int result);

  bool initData();
  //void prepareCalcData();
  void applyWallMove();
  void evalMoveBorderCellsX(int step);

  void updateABGMinMax(float x, float y, float z, VecF & min, VecF & max);
  void SetCellBug(int id, BugType bug, int type);

  inline int randInt(int max = RAND_MAX){
    if(max == RAND_MAX)return rand();
    if(max <  RAND_MAX)return rand()%max;
    int mult   = max / RAND_MAX;
    int result = 0;
    while(mult > 0){
      result += rand();
      mult--;
    }
    int offset = max - mult * RAND_MAX;
    if(offset <= 0)return result;
    return result + rand()%offset;
  }

};

#endif // PROCESSOR_H
