#ifndef STABIL_H
#define STABIL_H

#include "cudadevice.h"

class Stabilisation {
public:
  Stabilisation();
  bool process(ProjectF * prj, ProjectDataF * data, float stopValue = 0.0001f, int totalLoops = 1000);
private:
  float stabilBorder(int idx, ProjectF * prj, ProjectDataF * data);
  float stabilVac(int idx, ProjectF * prj, ProjectDataF * data);
  float stabilSub(int idx, ProjectF * prj, ProjectDataF * data);
  float stabilNear(int idx, ProjectF * prj, ProjectDataF * data);
  float stabilBase(int idx, ProjectF * prj, ProjectDataF * data);

  void prepareMateOptPos(VecF * mateOptPos, CrystalMatrixType matrixType, VecF & alpha, VecF & beta, VecF & gama, VecF & inPos, int mateIdx);

};

#endif
